routes/web.php
<?php

use App\Http\Controllers\Admin\DashboardController as AdminDashboardController;
use App\Http\Controllers\Admin\UserController as AdminUserController;
use App\Http\Controllers\Admin\StaffController as AdminStaffController;
use App\Http\Controllers\Admin\ProductController as AdminProductController;
use App\Http\Controllers\Admin\OrderController as AdminOrderController;
use App\Http\Controllers\User\DashboardController as UserDashboardController;
use App\Http\Controllers\User\OrderController as UserOrderController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes([
    'register' => false
]);

Route::prefix('admin')->name('admin.')->group(function(){
    // Admin Routes
    Route::middleware(['auth', 'role:admin'])->group(function(){
        Route::get('/', [AdminDashboardController::class, 'index'])->name('index');
    });

    // Admin & Staff Routes
    Route::middleware(['auth', 'role:admin,staff'])->group(function(){
        Route::prefix('user')->name('user.')->group(function(){
            Route::get('/', [AdminUserController::class, 'index'])->name('index');
            Route::get('/create', [AdminUserController::class, 'create'])->name('create');
            Route::post('/create', [AdminUserController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminUserController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminUserController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminUserController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminUserController::class, 'delete'])->name('delete');
        });

        Route::prefix('staff')->name('staff.')->group(function(){
            Route::get('/', [AdminStaffController::class, 'index'])->name('index');
            Route::get('/create', [AdminStaffController::class, 'create'])->name('create');
            Route::post('/create', [AdminStaffController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminStaffController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminStaffController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminStaffController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminStaffController::class, 'delete'])->name('delete');
        });

        Route::prefix('product')->name('product.')->group(function(){
            Route::get('/', [AdminProductController::class, 'index'])->name('index');
            Route::get('/create', [AdminProductController::class, 'create'])->name('create');
            Route::post('/create', [AdminProductController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminProductController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminProductController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminProductController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminProductController::class, 'delete'])->name('delete');
        });

        Route::prefix('order')->name('order.')->group(function(){
            Route::get('/', [AdminOrderController::class, 'index'])->name('index');
            Route::get('/detail/{code}', [AdminOrderController::class, 'detail'])->name('detail');
            Route::post('/confirm', [AdminOrderController::class, 'confirm'])->name('confirm');
            Route::post('/reject', [AdminOrderController::class, 'reject'])->name('reject');
        });
    });
});

// User Routes
Route::middleware(['auth', 'role:user'])->group(function(){
    Route::get('/', [UserDashboardController::class, 'index'])->name('index');

    Route::prefix('order')->name('order.')->group(function(){
        Route::get('/', [UserOrderController::class, 'index'])->name('index');
        Route::get('/detail/{code}', [UserOrderController::class, 'detail'])->name('detail');
        Route::post('/add-to-cart', [UserOrderController::class, 'addToCart'])->name('addToCart');
        Route::get('/cart', [UserOrderController::class, 'cart'])->name('cart');
        Route::post('/checkout', [UserOrderController::class, 'checkout'])->name('checkout');
    });
});

resources/views/cart.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">{{ __('Cart') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    <div class="row">
                        @php
                            $total_price = 0
                        @endphp
                        @foreach($carts as $cart)
                        <div class="col-12 mb-2">
                            <div class="d-flex align-items-center" style="border: 1px solid #bbb; border-radius: 4px;">
                                <div class="col-1">
                                    <img class="img-fluid" src="{{ $cart->product->product_image_url }}" />
                                </div>
                                <div class="col-8 px-3">
                                    {{ $cart->product->name }}
                                </div>
                                <div class="col-1 text-center">
                                    x{{ $cart->qty }}
                                </div>
                                <div class="col-2 text-end pe-3">
                                    {{ 'Rp'.number_format($cart->product->selling_price, 0, ',', '.') }}
                                </div>
                            </div>
                        </div>

                        @php
                            $total_price += ($cart->product->selling_price * $cart->qty)
                        @endphp
                        @endforeach
                        <form action="{{ route('order.checkout') }}" method="POST">
                            @csrf
                            <input type="hidden" name="total_price" value="{{ $total_price }}" />
                            <div class="col-12 mt-2 text-end pe-4">
                                <div>Total Price</div>
                                <h4>{{ 'Rp'.number_format($total_price, 0, ',', '.') }}</h4>
                                <button class="btn btn-success" type="submit">Checkout</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">{{ __('Product Catalog') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    @foreach($products as $product)
                    <div class="card" style="width: 18rem;">
                        <img src="{{ $product->product_image_url }}" class="card-img-top" alt="{{ $product->name }}">
                        <div class="card-body">
                            <h5 class="card-title">{{ $product->name }}</h5>
                            <p class="card-text">{{ $product->description }}</p>
                            <hr>
                            <h4>{{ 'Rp'.number_format($product->selling_price, 0, ',', '.') }}</h4>
                            <hr>
                            <form action="{{ route('order.addToCart') }}" method="POST">
                                @csrf
                                <input type="hidden" name="product_id" value="{{ $product->id }}" />
                                <div class="d-flex">
                                    <input value="1" type="number" class="form-control text-center" style="width: 30%;" name="qty" />
                                    <button type="submit" class="ms-auto btn btn-success">Add to Cart</a>
                                </div>
                            </form>
                        </div>
                    </div>
                    @endforeach
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/order-detail.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <section class="h-100 gradient-custom">
        <div class="container py-5 h-100">
            <div class="row d-flex justify-content-center align-items-center h-100">
            <div class="col-lg-10 col-xl-8">
                <div class="card" style="border-radius: 10px;">
                <div class="card-header px-4 py-5">
                    <h5 class="mb-0">Thanks for your Order, <span>{{ auth()->user()->name }}</span>!</h5>
                </div>
                <div class="card-body p-4">
                    <div class="d-flex justify-content-between align-items-center mb-4">
                    <p class="lead fw-normal mb-0">Receipt</p>
                    <p class="small mb-0">
                        Status : 
                        @if($order->status == 'waiting_confirmation')
                        Waiting Confirmation
                        @elseif($order->status == 'completed')
                        Completed
                        @elseif($order->status == 'rejected')
                        Rejected
                        @endif
                    </p>
                    </div>
                    <div class="card shadow-0 border mb-4">
                        <div class="card-body">
                            @foreach($order->items as $item)
                            <div class="row">
                                <div class="col-md-2">
                                    <img src="{{ $item->product->product_image_url }}"
                                    class="img-fluid" alt="Phone">
                                </div>
                                <div class="col-md-6 text-center d-flex justify-content-center align-items-center">
                                    <p class="mb-0">{{ $item->product->name }}</p>
                                </div>
                                <div class="col-md-2 text-center d-flex justify-content-center align-items-center">
                                    <p class="mb-0 small">Qty: {{ $item->qty }}</p>
                                </div>
                                <div class="col-md-2 text-center d-flex justify-content-center align-items-center">
                                    <p class="mb-0 small">{{ 'Rp'.number_format($item->price, 0, ',', '.') }}</p>
                                </div>
                            </div>
                            @endforeach
                        </div>
                    </div>

                    <div class="d-flex justify-content-between pt-2">
                    <p class="fw-bold mb-0">Order Details</p>
                    <p class="mb-0"><span class="fw-bold me-4">Total</span> {{ 'Rp'.number_format($order->total_price, 0, ',', '.') }}</p>
                    </div>

                    <div class="d-flex justify-content-between pt-2">
                    <p class="mb-0">Invoice Number : {{ $order->invoice_code }}</p>
                    </div>

                    <div class="d-flex justify-content-between">
                    <p class="mb-0">Invoice Date : {{ \Carbon\Carbon::parse($order->created_at)->format('d/m/Y H:i:s') }}</p>
                    </div>
                    <hr>
                    <a href="{{ route('order.index') }}" class="btn btn-sm btn-secondary">Back</a>
                </div>
                </div>
            </div>
            </div>
        </div>
        </section>
    </div>
</div>
@endsection

resources/views/order.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">{{ __('My Transaction') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    <table class="table table-hover">
                        <thead>
                            <tr>
                                <th class="text-center">No</th>
                                <th>Invoice Number</th>
                                <th>Date</th>
                                <th>Summary</th>
                                <th>Total Transaction</th>
                                <th>Status</th>
                                <th class="text-center">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($orders as $key => $order)
                            <tr>
                                <td class="text-center">{{ $orders->firstItem() + $key }}</td>
                                <td>{{ $order->invoice_code }}</td>
                                <td>{{ \Carbon\Carbon::parse($order->created_at)->format('d/m/Y H:i:s') }}</td>
                                <td>{{ $order->items->count().' Product(s)' }}</td>
                                <td>{{ 'Rp'.number_format($order->total_price, 0, ',', '.') }}</td>
                                <td>
                                @if($order->status == 'waiting_confirmation')
                                Waiting Confirmation
                                @elseif($order->status == 'completed')
                                Completed
                                @elseif($order->status == 'rejected')
                                Rejected
                                @endif
                                </td>
                                <td class="text-center">
                                    <a class="btn btn-sm btn-primary" href="{{ route('order.detail', $order->invoice_code) }}">Detail</a>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection